#include <stdlib.h>
#include <unistd.h>
#include <curses.h>
#include <stdio.h>
#include <sys/errno.h>
#include <fcntl.h>

#include "mix.h"

static void display_menu (int,int,int);
static int  initTest (WINDOW **);
int mixer_fd;

typedef struct stereovolume
{
  unsigned char left;
  unsigned char right;
} StereoVolume;
    
typedef struct volctrl
{
  int mixer_id;
  bool isvalid;
  StereoVolume volume;
} VolumeControl;

VolumeControl all[20];


struct commands
{
 char *text;
 void (*function)(WINDOW *);
};
typedef struct commands COMMAND;
#define MAX_VOLUME 50

bool quit;

int main(int argc, char **argv)
{
WINDOW  *win;
VolumeControl testme;

int key,new_option[20],ret,i,current,k;
mixer_fd = open ("/dev/mixer", O_RDWR, 0);
if (mixer_fd < 0)
printf ("Error opening mixer device\n"), exit (1);
k = 0;
for(i = 0;i<13;i++)
{
ret = ioctl(mixer_fd,MIXER_READ(i),&testme.volume);
if (ret != -1)
{
all[k].isvalid = 1;
all[k].mixer_id = i;
new_option[k] = testme.volume.left/2;
k++;
}
}
all[k].isvalid = 0;
current = 0;

quit=FALSE;

    if (!initTest (&win)) exit(1);

      if (has_colors())
      {
       init_pair(1,COLOR_WHITE,COLOR_BLUE);
       init_pair(2,COLOR_WHITE,COLOR_RED);
      }
      else
       wattrset(win, A_REVERSE);

    erase();
    for (i = 0;i<20;i++)
    {
    if (all[i].isvalid == 1)
    {
    if (i == 0)
    {
      display_menu(new_option[i],i,'X');
    }
    else
    {
      display_menu(new_option[i],i,' ');
    
    }
    }
    
    }
    while(1)
      {
       noecho();
       keypad(stdscr,TRUE);
       raw();
       key = getch();
       switch(key)
         {
          case KEY_LEFT:
                         new_option[current] = (new_option[current] == 0) ? new_option[current] : new_option[current]-1;
                         display_menu(new_option[current],current,'X');
                         break;
          case KEY_RIGHT:
                         new_option[current] = (new_option[current] == MAX_VOLUME) ? new_option[current] : new_option[current]+1;
                         display_menu(new_option[current],current,'X');
                         break;
	  case KEY_UP:
	                 if (current == 0) break;
                         display_menu(new_option[current],current,' ');
	                 current--;
                         display_menu(new_option[current],current,'X');
			 break;
	  case KEY_DOWN:
	                 if (all[current+1].isvalid == 0) break;
                         display_menu(new_option[current],current,' ');
	                 current++;
                         display_menu(new_option[current],current,'X');
			 break;
	  case KEY_HOME:
                         display_menu(0,current,'X');
			 new_option[current] = 0;
			 
			 break;
	  case KEY_END:
                         display_menu(50,current,'X');
			 new_option[current] = 50;
			 break;
			 
          case 'Q':
	  case KEY_BREAK:
          case 'q':
         quit = TRUE;
          break;
            default:       break;
         }
        if (quit == TRUE)
      break;
        }
    delwin (win);
    curs_set(1);
    endwin();
    exit(0);
}


static
int initTest (WINDOW **win)
{

    initscr();
    if (has_colors())
       start_color();
    *win = newwin(0,0,0,0);
    if(*win == NULL)
    {   endwin();
        return 0;
    }
    return 1;
}



static void
display_menu(int new_option,int current,int chrx)
{
int i,ret,count;
int recmask;
char chr[255];
StereoVolume volume1;
curs_set(0);
if (chrx == ' ')
{
attrset(COLOR_PAIR(1));
}
else
{
attrset(COLOR_PAIR(2));
}
for (i = 0;i<MAX_VOLUME+1;i++)
mvaddstr(current,i," ");
if (chrx == ' ')
{
attrset(COLOR_PAIR(2));
}
else
{
attrset(COLOR_PAIR(1));
}

switch (all[current].mixer_id)
{
 case NMIX_SOUND_MIXER_VOLUME:
 sprintf(chr,"Master");
 break;
 case NMIX_SOUND_MIXER_BASS:
 sprintf(chr,"Bass");
 break;
 case NMIX_SOUND_MIXER_TREBLE:
 sprintf(chr,"Treble");
 break;
 case NMIX_SOUND_MIXER_SYNTH:
 sprintf(chr,"Synth");
 break;
 case NMIX_SOUND_MIXER_PCM:
 sprintf(chr,"PCM");
 break;
 case NMIX_SOUND_MIXER_SPEAKER:
 sprintf(chr,"Speaker");
 break;
 case NMIX_SOUND_MIXER_LINE:
 sprintf(chr,"Line");
 break;
 case NMIX_SOUND_MIXER_MIC:
 sprintf(chr,"Mic");
 break;
 case NMIX_SOUND_MIXER_CD:
 sprintf(chr,"CD");
 break;
 case NMIX_SOUND_MIXER_IMIX:
 sprintf(chr,"in Mix");
 break;
 case NMIX_SOUND_MIXER_ALTPCM:
 sprintf(chr,"alt. PCM");
 break;
 case NMIX_SOUND_MIXER_RECLEV:
 sprintf(chr,"Rec. Level");
 break;
 case NMIX_SOUND_MIXER_IGAIN:
 sprintf(chr,"Input Gain");
 break;
 case NMIX_SOUND_MIXER_OGAIN:
 sprintf(chr,"Output Gain");
 break;
 case NMIX_SOUND_MIXER_LINE1:
 sprintf(chr,"Line1");
 break;
 case NMIX_SOUND_MIXER_LINE2:
 sprintf(chr,"Line2");
 break;
 case NMIX_SOUND_MIXER_LINE3:
 sprintf(chr,"Line3");
 break;
 case NMIX_SOUND_MIXER_DIGITAL1:
 sprintf(chr,"Digital1");
 break;
 case NMIX_SOUND_MIXER_DIGITAL2:
 sprintf(chr,"Digital2");
 break;
 case NMIX_SOUND_MIXER_DIGITAL3:
 sprintf(chr,"Digital3");
 break;
 case NMIX_SOUND_MIXER_PHONEIN :
 sprintf(chr,"PhoneIn");
 break;
 case NMIX_SOUND_MIXER_PHONEOUT:
 sprintf(chr,"PhoneOut");
 break;
 case NMIX_SOUND_MIXER_VIDEO   :
 sprintf(chr,"Video");
 break;
 case NMIX_SOUND_MIXER_RADIO   :
 sprintf(chr,"Radio");
 break;
 case NMIX_SOUND_MIXER_MONITOR :
 sprintf(chr,"Monitor");
 break;
 default:
 sprintf(chr,"ID %i",all[current].mixer_id);
 break;
 
}
 strcat (chr,"             ");
 chr[10] = '\0';
/*                if ((1 << all[current].mixer_id) & recmask)
		{
		 strcat (chr,"-");
		}
		else
		{
		}
*/
 mvaddstr(current,i+1,chr);




if (chrx == ' ') attrset(COLOR_PAIR(1));
else attrset(COLOR_PAIR(2));

 sprintf(chr,"@");
 mvaddstr(current,new_option,chr);
 i = all[current].mixer_id;
 volume1.left = new_option*2;
 volume1.right =new_option*2;
 ret = ioctl(mixer_fd,MIXER_WRITE(i),&volume1);
 attrset(A_NORMAL);
 
}

