/*
 * Mixer devices
 *
 * There can be up to 20 different analog mixer channels. The
 * NMIX_SOUND_MIXER_NRDEVICES gives the currently supported maximum.
 * The NMIX_SOUND_MIXER_READ_DEVMASK returns a bitmask which tells
 * the devices supported by the particular mixer.
*/

/* this file is created from <linux/soundcard.h>
   but due some changes from 2.0 -> 2.2 it has been
   put here.
*/

#include <linux/soundcard.h>
 
#define NMIX_SOUND_MIXER_NRDEVICES   25
#define NMIX_SOUND_MIXER_VOLUME      0
#define NMIX_SOUND_MIXER_BASS        1
#define NMIX_SOUND_MIXER_TREBLE      2
#define NMIX_SOUND_MIXER_SYNTH       3
#define NMIX_SOUND_MIXER_PCM         4
#define NMIX_SOUND_MIXER_SPEAKER     5
#define NMIX_SOUND_MIXER_LINE        6
#define NMIX_SOUND_MIXER_MIC         7
#define NMIX_SOUND_MIXER_CD          8
#define NMIX_SOUND_MIXER_IMIX        9       /*  Recording monitor  */
#define NMIX_SOUND_MIXER_ALTPCM      10
#define NMIX_SOUND_MIXER_RECLEV      11      /* Recording level */
#define NMIX_SOUND_MIXER_IGAIN       12      /* Input gain */
#define NMIX_SOUND_MIXER_OGAIN       13      /* Output gain */

/*
 * The AD1848 codec and compatibles have three line level inputs
 * (line, aux1 and aux2). Since each card manufacturer have assigned
 * different meanings to these inputs, it's inpractical to assign
 * specific meanings (line, cd, synth etc.) to them
*/
#define NMIX_SOUND_MIXER_LINE1       14      /* Input source 1  (aux1) */
#define NMIX_SOUND_MIXER_LINE2       15      /* Input source 2  (aux2) */
#define NMIX_SOUND_MIXER_LINE3       16      /* Input source 3  (line) */
#define NMIX_SOUND_MIXER_DIGITAL1    17      /* Digital (input) 1 */
#define NMIX_SOUND_MIXER_DIGITAL2    18      /* Digital (input) 2 */
#define NMIX_SOUND_MIXER_DIGITAL3    19      /* Digital (input) 3 */
#define NMIX_SOUND_MIXER_PHONEIN     20      /* Phone input */ 
#define NMIX_SOUND_MIXER_PHONEOUT    21      /* Phone output */
#define NMIX_SOUND_MIXER_VIDEO       22      /* Video/TV (audio) in */
#define NMIX_SOUND_MIXER_RADIO       23      /* Radio in */
#define NMIX_SOUND_MIXER_MONITOR     24      /* Monitor (usually mic) volume */
	    